class Doctrine

    def initialize

    end

    # @param [string] data_container_name
    # @param [string] db_container_name
    def create_database(data_container_name, db_container_name = nil)
        puts '-- Creating Symfony Doctrine database'
        docker_command = get_docker_command(data_container_name, db_container_name) << 'doctrine:database:create'
        puts '---- Running: ' << docker_command
        output = `#{docker_command}`
        print output
        fail 'Database creation failed!' unless /(exists|Created)/.match(output)
    end

    # @param [string] data_container_name
    # @param [string] db_container_name
    def run_migrations(data_container_name, db_container_name = nil)
        puts '-- Running Symfony Doctrine migrations'
        docker_command = get_docker_command(data_container_name, db_container_name) << 'doctine:migrations:migrate --no-interaction'
        puts '---- Running: ' << docker_command
        fail 'Database migrations failed!' unless system docker_command
    end

    private
    # @param [string] data_container_name
    # @param [string] db_container_name
    # @return [string]
    def get_docker_command(data_container_name, db_container_name = nil)
        docker_command = "docker run --rm --volumes-from #{data_container_name} "
        if db_container_name != nil
            docker_command << "--link #{db_container_name}:#{db_container_name} "
        end
        docker_command << 'vjftw/php-cli app/console --ansi '

        docker_command
    end

end